﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using JPK_v1.Constans;
using System.IO;
using System.IO.Compression;
using System.Security.Cryptography;
using System.Net;
using System.Security.Cryptography.X509Certificates;
using System.Net.Security;
using JPK_v1.Core;


namespace JPK_v1
{
    public partial class Header : UserControl
    {
        private WalutaLista wal;
        private US us;
        private JG  jg;
        private TCels cel;
        public Podmiot lPodmiot { get; set; }
        public SP lSp { get; set; }
        public SP_CTRL lSpCtr { get; set; }

        public ZOIS zois { get; set; }
        public KGZapis kgza { get; set; }
        public ZA lZa { get; set; }
        public ZA_CTRL lZaCtr { get; set; }
        public bool Faktury { get; set; }
		public bool Kg { get; set; }
        public bool WB { get; set; }
        public Rachunek WBRachunek { get; set; }
        public WyciagWier WBPozycje { get; set; }
        public WyciagWierszCtrl WBCtrl { get; set; }
        public Header()
        {
            InitializeComponent();
            cel = new TCels();
            foreach (var item in cel.Cel)
            {
                cCel.Items.Add(item.Describe);
            }
            wal = new WalutaLista();
            foreach (var item in wal.Waluta)
            {
                CWaluta.Items.Add(item.Kod);
            }
            jg = new JG();
            foreach (var item in jg.Lista )
            {
                cJG.Items.Add(item.Kod);
            }
            us = new US();
            foreach (var item in us.Lista)
            {
                cUs.Items.Add(item.Kod);
            }
        }
         public void InitDok(String aDok)
            {
                if(aDok.Equals("VAT") == true)
                {
                    tKodFor.Text = JPK_VAT_v1.TKodFormularza.JPK_VAT.ToString();
                    tWariant.Text= "3";
                }
                if (aDok.Equals("FA") == true)
                {
                    tKodFor.Text = JPK_FA_v1.TKodFormularza.JPK_FA.ToString();
                    tWariant.Text = "3";
                }
				if (aDok.Equals("KG") == true)
				{
					tKodFor.Text = JPK_KG_v1.TKodFormularza.JPK_KR.ToString();
					tWariant.Text = "1";
				}
                if (aDok.Equals("WB") == true)
                {
                    tKodFor.Text = JPK_WB_v1.TKodFormularza.JPK_WB.ToString();
                    tWariant.Text = "1";
                }
        }

         private void CWaluta_SelectedIndexChanged(object sender, EventArgs e)
         {
             tWalDes.Text = wal.Waluta[CWaluta.SelectedIndex].Opis;

         }

         private void bIN_Click(object sender, EventArgs e)
         {
             if (this.Faktury == false || this.Kg == false || this.WB == false)
             {
				if (lSp != null)
				{
					lSp.clearSP();
				}
             }
             tstatus.Text = "";
             OpenFileDialog openFileDialog1 = new OpenFileDialog();
             openFileDialog1.Multiselect = false;
             openFileDialog1.Title = "Podaj plik do przetworzenia";
             openFileDialog1.Filter = "CSV|*.csv";
             if (openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
             {
                 fileIN.Text = openFileDialog1.FileName;
                 string file = Path.GetFileNameWithoutExtension(fileIN.Text);
                 file = file + ".xml";
                 file = Path.GetDirectoryName(fileIN.Text) + "\\" +file;
                 fileOut.Text = file;
                 StreamReader sr = new StreamReader(fileIN.Text, Encoding.Default);
                 string line = sr.ReadLine();
                 string [] atr = line.Split('|');

                 cJG.SelectedItem = atr[0];
                 int l = 0;
                 foreach (var item in jg.Lista)
                 {
                     if (item.Kod.Equals(atr[0]) == true)
                     {
                         cJG.SelectedIndex = l;
                     }
                     l += 1;
                 }
                 tJG.Text = jg.Lista[cJG.SelectedIndex].Describe;
                 lPodmiot.SetPodmiot(jg.Lista[cJG.SelectedIndex]);

                 dateC.Value = new DateTime(Convert.ToInt16(atr[3].Substring(0,4)),Convert.ToInt16(atr[3].Substring(4,2)),Convert.ToInt16(atr[3].Substring(6,2)));
                 dataOd.Value = new DateTime(Convert.ToInt16(atr[1].Substring(0, 4)), Convert.ToInt16(atr[1].Substring(4, 2)), Convert.ToInt16(atr[1].Substring(6, 2)));
                 dataDo.Value = new DateTime(Convert.ToInt16(atr[2].Substring(0, 4)), Convert.ToInt16(atr[2].Substring(4, 2)), Convert.ToInt16(atr[2].Substring(6, 2)));

                if (Faktury == false && this.Kg == false && this.WB == false)
                {
                    JPK_VAT_v1.JPKSprzedazWiersz sp;
                    SpCtrl kon = new SpCtrl();
                    SpCtrl konz = new SpCtrl();

                    ProgresMy po = new ProgresMy();
                    po.Start();

                    while (sr.EndOfStream == false)
                    {
                        line = sr.ReadLine();
                        atr = line.Split('|');


                        if (atr[1].Equals("S") == true)
                        {
                            sp = new JPK_VAT_v1.JPKSprzedazWiersz();
                            sp.LpSprzedazy = Convert.ToInt32(atr[0]).ToString();
                            sp.DowodSprzedazy = atr[5];
                            sp.NazwaKontrahenta = atr[6];
                            sp.AdresKontrahenta = atr[7];
                            sp.NrKontrahenta = atr[46];
                            sp.DataSprzedazy = new DateTime(Convert.ToInt16(atr[3].Substring(0, 4)), Convert.ToInt16(atr[3].Substring(4, 2)), Convert.ToInt16(atr[3].Substring(6, 2)));
                            // sp.DataSprzedazySpecified = true;
                            sp.DataWystawienia = new DateTime(Convert.ToInt16(atr[4].Substring(0, 4)), Convert.ToInt16(atr[4].Substring(4, 2)), Convert.ToInt16(atr[4].Substring(6, 2)));
                            sp.K_10 = Convert.ToDecimal(atr[8].Replace('.', ','));
                            sp.K_11 = Convert.ToDecimal(atr[9].Replace('.', ','));
                            sp.K_12 = Convert.ToDecimal(atr[10].Replace('.', ','));
                            sp.K_13 = Convert.ToDecimal(atr[11].Replace('.', ','));
                            sp.K_14 = Convert.ToDecimal(atr[12].Replace('.', ','));
                            sp.K_15 = Convert.ToDecimal(atr[13].Replace('.', ','));
                            sp.K_16 = Convert.ToDecimal(atr[14].Replace('.', ','));
                            sp.K_17 = Convert.ToDecimal(atr[15].Replace('.', ','));
                            sp.K_18 = Convert.ToDecimal(atr[16].Replace('.', ','));
                            sp.K_19 = Convert.ToDecimal(atr[17].Replace('.', ','));
                            sp.K_20 = Convert.ToDecimal(atr[18].Replace('.', ','));
                            sp.K_21 = Convert.ToDecimal(atr[19].Replace('.', ','));
                            sp.K_22 = Convert.ToDecimal(atr[20].Replace('.', ','));
                            sp.K_23 = Convert.ToDecimal(atr[21].Replace('.', ','));
                            sp.K_24 = Convert.ToDecimal(atr[22].Replace('.', ','));
                            sp.K_25 = Convert.ToDecimal(atr[23].Replace('.', ','));
                            sp.K_26 = Convert.ToDecimal(atr[24].Replace('.', ','));
                            sp.K_27 = Convert.ToDecimal(atr[25].Replace('.', ','));
                            sp.K_28 = Convert.ToDecimal(atr[26].Replace('.', ','));
                            sp.K_29 = Convert.ToDecimal(atr[27].Replace('.', ','));
                            sp.K_30 = Convert.ToDecimal(atr[28].Replace('.', ','));
                            sp.K_31 = Convert.ToDecimal(atr[29].Replace('.', ','));
                            sp.K_32 = Convert.ToDecimal(atr[30].Replace('.', ','));
                            sp.K_33 = Convert.ToDecimal(atr[31].Replace('.', ','));
                            sp.K_34 = Convert.ToDecimal(atr[32].Replace('.', ','));
                            sp.K_35 = Convert.ToDecimal(atr[33].Replace('.', ','));
                            sp.K_36 = Convert.ToDecimal(atr[34].Replace('.', ','));
                            sp.K_37 = Convert.ToDecimal(atr[35].Replace('.', ','));
                            sp.K_38 = Convert.ToDecimal(atr[36].Replace('.', ','));
                            sp.K_39 = Convert.ToDecimal(atr[37].Replace('.', ','));
                            lSp.addPozSP(sp);
                            kon.Ile += 1;
                            kon.Kwota = kon.Kwota + sp.K_20 + sp.K_18 + sp.K_16 + sp.K_24 + sp.K_26 + sp.K_28 + sp.K_30 + sp.K_33 + sp.K_35 + sp.K_36 - sp.K_38 - sp.K_39;

                        }
                        else
                        {
                            JPK_VAT_v1.JPKZakupWiersz zk = new JPK_VAT_v1.JPKZakupWiersz();
                            zk.LpZakupu = Convert.ToInt32(atr[0]).ToString();
                            zk.DowodZakupu = atr[5];
                            zk.NazwaDostawcy = atr[6];
                            zk.AdresDostawcy = atr[7];
                            zk.NrDostawcy = atr[46];
                            zk.DataWplywu = new DateTime(Convert.ToInt16(atr[3].Substring(0, 4)), Convert.ToInt16(atr[3].Substring(4, 2)), Convert.ToInt16(atr[3].Substring(6, 2)));
                            //    zk.DataWplywuSpecified = true;
                            zk.K_43 = Convert.ToDecimal(atr[38].Replace('.', ','));
                            zk.K_44 = Convert.ToDecimal(atr[39].Replace('.', ','));
                            zk.K_45 = Convert.ToDecimal(atr[40].Replace('.', ','));
                            zk.K_46 = Convert.ToDecimal(atr[41].Replace('.', ','));
                            zk.K_47 = Convert.ToDecimal(atr[42].Replace('.', ','));
                            zk.K_48 = Convert.ToDecimal(atr[43].Replace('.', ','));
                            zk.K_49 = Convert.ToDecimal(atr[44].Replace('.', ','));
                            zk.K_50 = Convert.ToDecimal(atr[45].Replace('.', ','));
                            lZa.ZaAdd(zk);
                            konz.Ile += 1;
                            konz.Kwota = konz.Kwota + zk.K_44 + zk.K_46 + zk.K_48 + zk.K_47;
                        }

                    }
                    lSpCtr.SpCtrlAdd(kon);
                    lZaCtr.ZaCtrlAdd(konz);
                    po.Stop();
                }
                else if (this.WB == true)
                {
                    JPK_WB_v1.JPK wb = new JPK_WB_v1.JPK();
                    JPK_WB_v1.JPKWyciagWiersz wp = null;
                    int licz = 0;
                    JPK_WB_v1.JPKWyciagCtrl wpc = new JPK_WB_v1.JPKWyciagCtrl();
                    WBPozycje.clearWB();
                    while (sr.EndOfStream == false)
                    {
                        line = sr.ReadLine();
                        atr = line.Split('|');


                        if (atr[0].Equals("SA") == true)
                        {
                           wb.NumerRachunku = atr[2];
                           wb.Salda.SaldoPoczatkowe = Convert.ToDecimal(atr[3].Replace('.', ','));
                           wb.Salda.SaldoKoncowe = Convert.ToDecimal(atr[4].Replace('.', ','));
                        }
                        if (atr[0].Equals("PO") == true)
                        {
                            licz = licz + 1;
                            wp = new JPK_WB_v1.JPKWyciagWiersz();
                            wp.NumerWiersza = atr[1].ToString();
                            wp.DataOperacji = new DateTime(Convert.ToInt16(atr[2].Substring(0, 4)), Convert.ToInt16(atr[2].Substring(4, 2)), Convert.ToInt16(atr[2].Substring(6, 2)));
                            wp.NazwaPodmiotu = atr[3] + atr[4];
                            wp.OpisOperacji = atr[5];
                            wp.KwotaOperacji = Convert.ToDecimal(atr[6].Replace('.', ','));
                            wp.SaldoOperacji = Convert.ToDecimal(atr[7].Replace('.', ','));
                            WBPozycje.addPozWB(wp);
                            if (wp.KwotaOperacji > 0)
                            {
                                wpc.SumaUznan = wpc.SumaUznan + wp.KwotaOperacji;
                            }
                            else
                            {
                                wpc.SumaObciazen = wpc.SumaObciazen + wp.KwotaOperacji;
                            }
                        }
                    }
                    WBRachunek.AddData(wb);
                    wpc.LiczbaWierszy = licz.ToString();
                    WBCtrl.addPozWBC(wpc);
                }
                else if (this.Kg == true)
                {

                }
                else if (this.Faktury == true)
                {

                }
                else
                {

                }
             }
         }

         private void bout_Click(object sender, EventArgs e)
         {
             if (fileIN.Text.Equals("")== true)
             {
                 return;
             }
             StreamReader sr = new StreamReader(fileIN.Text,Encoding.Default);
             string line = sr.ReadLine();
             string[] atr;

             if (Faktury == true)
             {
                 JPK_FA_v1.JPK fa = new JPK_FA_v1.JPK();
                 if (cUs.SelectedIndex < 0)
                 {
                     return;
                 }
                 if (wal.Waluta[CWaluta.SelectedIndex].Kod.Equals("PLN") == true)
                 {
                 //   fa.Naglowek.DomyslnyKodWaluty = JPK_FA_v1.currCode_Type.PLN;
                 }
                 else
                 {
                  //  fa.Naglowek.DomyslnyKodWaluty = JPK_FA_v1.currCode_Type.EUR;
                 }
                fa.Naglowek = new JPK_FA_v1.JPKNaglowek();
                fa.Naglowek.KodUrzedu = new JPK_FA_v1.TKodUS();
                 if (us.Lista[cUs.SelectedIndex].Kod.Equals("0271") == true)
                 {

                     fa.Naglowek.KodUrzedu = JPK_FA_v1.TKodUS.Item0271;
                 }
				if (us.Lista[cUs.SelectedIndex].Kod.Equals("0225") == true)
				{
					fa.Naglowek.KodUrzedu = JPK_FA_v1.TKodUS.Item0225;
				}
				DateTime s = dataDo.Value;
                 fa.Naglowek.DataDo = s;
                 s = dataOd.Value;
                 fa.Naglowek.DataOd = s;

                 string ckod = cel.Cel[cCel.SelectedIndex].Key.ToString();
                 if (cel.Equals("") == true)
                 {
                     return;
                 }
                 fa.Naglowek.CelZlozenia = 1;

                 DateTime sw = dateC.Value;
                 fa.Naglowek.DataWytworzeniaJPK = sw;
				fa.Naglowek.KodFormularza = new JPK_FA_v1.TNaglowekKodFormularza();
                fa.Naglowek.WariantFormularza = 3;
                fa.Naglowek.CelZlozenia = 1;
    
                fa.Podmiot1 = new JPK_FA_v1.JPKPodmiot1();
                fa.Podmiot1.Item = new JPK_FA_v1.TAdresPolski1();
                // JPK_FA_v1.TAdresPolski1 adresPolski1 = new JPK_FA_v1.TAdresPolski1();
                ((JPK_FA_v1.TAdresPolski1)(fa.Podmiot1.Item)).Gmina = jg.Lista[cJG.SelectedIndex].Gmina;
                if (jg.Lista[cJG.SelectedIndex].Kraj.Equals("PL") == true)
                 {
                    ((JPK_FA_v1.TAdresPolski1)(fa.Podmiot1.Item)).KodKraju = JPK_FA_v1.TKodKraju.PL;
                }
                ((JPK_FA_v1.TAdresPolski1)(fa.Podmiot1.Item)).KodPocztowy = jg.Lista[cJG.SelectedIndex].Poczta;
                ((JPK_FA_v1.TAdresPolski1)(fa.Podmiot1.Item)).Miejscowosc = jg.Lista[cJG.SelectedIndex].MiastoPoczta;
                ((JPK_FA_v1.TAdresPolski1)(fa.Podmiot1.Item)).NrDomu = jg.Lista[cJG.SelectedIndex].Budynek;
                ((JPK_FA_v1.TAdresPolski1)(fa.Podmiot1.Item)).NrLokalu = jg.Lista[cJG.SelectedIndex].Dom;
                ((JPK_FA_v1.TAdresPolski1)(fa.Podmiot1.Item)).NrLokalu = "|||";
                //  adresPolski1.Poczta = jg.Lista[cJG.SelectedIndex].MiastoPoczta;
                ((JPK_FA_v1.TAdresPolski1)(fa.Podmiot1.Item)).Powiat = jg.Lista[cJG.SelectedIndex].Powiat;
                ((JPK_FA_v1.TAdresPolski1)(fa.Podmiot1.Item)).Ulica = jg.Lista[cJG.SelectedIndex].Ulica;
                ((JPK_FA_v1.TAdresPolski1)(fa.Podmiot1.Item)).Wojewodztwo = jg.Lista[cJG.SelectedIndex].Wojewodztwo;

                fa.Podmiot1.IdentyfikatorPodmiotu = new JPK_FA_v1.TIdentyfikatorOsobyNiefizycznej1();
                fa.Podmiot1.IdentyfikatorPodmiotu.NIP = jg.Lista[cJG.SelectedIndex].NIP;
                 fa.Podmiot1.IdentyfikatorPodmiotu.PelnaNazwa = jg.Lista[cJG.SelectedIndex].Describe;
            //     fa.Podmiot1.IdentyfikatorPodmiotu.REGON = jg.Lista[cJG.SelectedIndex].Regon;
            
                 JPK_FA_v1.JPKFaktura fak;
                 JPK_FA_v1.JPKFakturaCtrl fakctr = new JPK_FA_v1.JPKFakturaCtrl();
                 JPK_FA_v1.JPKFakturaWiersz wiersz;
                 JPK_FA_v1.JPKFakturaWierszCtrl wierszctrl = new JPK_FA_v1.JPKFakturaWierszCtrl();
                // JPK_FA_v1.JPKStawkiPodatku stawki;
                 int liczba = 0;
                 int liczba1 = 0;
                fa.Faktura = new List<JPK_FA_v1.JPKFaktura>();
                fa.FakturaWiersz = new List<JPK_FA_v1.JPKFakturaWiersz>();
                 while (sr.EndOfStream == false)
                 {
                     line = sr.ReadLine();
                     atr = line.Split('|');

                     if (atr[0].Equals("P") == true) //wiersze faktur
                     {
                         wiersz = new JPK_FA_v1.JPKFakturaWiersz(); //3
                         wiersz.P_2B = atr[3];
                         wiersz.P_7 = atr[4];
                         wiersz.P_8A = atr[5];
                         wiersz.P_8B = Convert.ToDecimal(atr[6].Replace('.', ','));
                        wiersz.P_9A = Convert.ToDecimal(atr[7].Replace('.', ','));
                        wiersz.P_9B = Convert.ToDecimal(atr[8].Replace('.', ','));
                        wiersz.P_10 = Convert.ToDecimal(atr[9].Replace('.', ','));
                        wiersz.P_11 = Convert.ToDecimal(atr[10].Replace('.', ','));
                        wiersz.P_11A = Convert.ToDecimal(atr[11].Replace('.', ','));
                        if (atr[12].Equals("23") == true)
                        {
                            wiersz.P_12 = JPK_FA_v1.JPKFakturaWierszP_12.Item23;
                        }
                        if (atr[12].Equals("8") == true)
                        {
                            wiersz.P_12 = JPK_FA_v1.JPKFakturaWierszP_12.Item8;
                        }
                        if (atr[12].Equals("ZW") == true)
                        {
                            wiersz.P_12 = JPK_FA_v1.JPKFakturaWierszP_12.zw;
                        }
                         fa.FakturaWiersz.Add(wiersz);
                         liczba1 = liczba1 + 1;
                         
                         wierszctrl.WartoscWierszyFaktur = wierszctrl.WartoscWierszyFaktur + wiersz.P_11 ;
                     }
                     else
                     {
                         fak = new JPK_FA_v1.JPKFaktura();
                        if (wal.Waluta[CWaluta.SelectedIndex].Kod.Equals("PLN") == true)
                        {
                            fak.KodWaluty = JPK_FA_v1.currCode_Type.PLN;
                        }
                        else
                        {
                            fak.KodWaluty = JPK_FA_v1.currCode_Type.EUR;
                        }
                      
                         if (atr[1].Equals("S") == true){

                        fak.P_1 = new DateTime(Convert.ToInt16(atr[3].Substring(0, 4)), Convert.ToInt16(atr[3].Substring(4, 2)), Convert.ToInt16(atr[3].Substring(6, 2)));
                     }
                        fak.P_2A = atr[4];
                         if(atr[1].Equals("S") == true)
                         {
                            fak.P_3A = atr[5];
                            fak.P_3B = atr[6];
                            if (atr[7].Equals("PL") == true)
                            {
                                fak.P_4A = JPK_FA_v1.MSCountryCode_Type.PL;
                             //   fak.P_5A = JPK_FA_v1.MSCountryCode_Type.PL;
                                fak.P_5B = atr[7];
                                fak.P_4B = fa.Podmiot1.IdentyfikatorPodmiotu.NIP;
                            }
                            else
                            {
                                fak.P_4A = JPK_FA_v1.MSCountryCode_Type.PL;
                                fak.P_5A = JPK_FA_v1.MSCountryCode_Type.PL;
                                fak.P_5B = atr[7];
                                fak.P_4B = fa.Podmiot1.IdentyfikatorPodmiotu.NIP;
                                fak.P_4ASpecified = true;
                                fak.P_5ASpecified = false;
                            }
                           
                            if (atr[1].Equals("S") == true)
                            {
                                fak.P_6 = new DateTime(Convert.ToInt16(atr[9].Substring(0, 4)), Convert.ToInt16(atr[9].Substring(4, 2)), Convert.ToInt16(atr[9].Substring(6, 2)));
                            }
                        }

                        fak.P_3C = fa.Podmiot1.IdentyfikatorPodmiotu.PelnaNazwa;
                        fak.P_3D = jg.Lista[cJG.SelectedIndex].Ulica + " " + jg.Lista[cJG.SelectedIndex].Budynek + " " + jg.Lista[cJG.SelectedIndex].Poczta + " " + jg.Lista[cJG.SelectedIndex].MiastoPoczta;





                        fak.P_13_1 = Convert.ToDecimal(atr[10].Replace('.', ',')); 
                        fak.P_14_1 =Convert.ToDecimal(atr[11].Replace('.', ','));
                        fak.P_13_2 =Convert.ToDecimal(atr[12].Replace('.', ','));
                        fak.P_14_2 =Convert.ToDecimal(atr[13].Replace('.', ','));
                        fak.P_13_3 =Convert.ToDecimal(atr[14].Replace('.', ','));
                        fak.P_14_3 =Convert.ToDecimal(atr[15].Replace('.', ','));
                        fak.P_13_4=Convert.ToDecimal(atr[16].Replace('.', ','));
                        fak.P_14_4=Convert.ToDecimal(atr[17].Replace('.', ','));
                        fak.P_13_5=Convert.ToDecimal(atr[18].Replace('.', ','));
                      //  fak.P_14_5=Convert.ToDecimal(atr[19].Replace('.', ','));
                        fak.P_13_6=Convert.ToDecimal(atr[20].Replace('.', ','));
                        fak.P_13_7=Convert.ToDecimal(atr[21].Replace('.', ','));
                        fak.P_15=Convert.ToDecimal(atr[22].Replace('.', ','));
                         if(atr[23].Equals("X")==true)
                         {
                            fak.P_16= true;
                         }else{
                             fak.P_16= false;
                         }
                         if(atr[24].Equals("X")==true) 
                         {
                            fak.P_17= true;
                         }else{
                            fak.P_17= false;
                         }
                          if(atr[25].Equals("X")==true) 
                          {
                             fak.P_18= true;
                          }
                          else
                          {
                              fak.P_18= false;
                          }
                           if(atr[26].Equals("X")==true) 
                           {
                                fak.P_19= true;
                                fak.P_19A= atr[27];
                                fak.P_19B= atr[27]; 
                                fak.P_19C= atr[28];
                           }else{
                                fak.P_19 = false;
                           }
                          if(atr[29].Equals("X")==true) {
                               fak.P_20= true;
                               fak.P_20A=atr[30];
                               fak.P_20B=atr[30];
                          }
                          else
                          {
                               fak.P_20= false;

                          }
                        if(atr[31].Equals("X")==true) {
                                fak.P_21= true;
                                fak.P_21A=atr[32];
                        fak.P_21B=atr[33];
                        fak.P_21C=atr[34];
                       }
                       else
                       {
                           fak.P_21= false;
                       }
                        //  fak.P_22A=new DateTime(Convert.ToInt16(atr[3].Substring(0, 4)), Convert.ToInt16(atr[3].Substring(4, 2)), Convert.ToInt16(atr[3].Substring(6, 2)));
                        fak.P_22A = new DateTime(1900, 01,01);

                        fak.P_22B = "0";//atr[37];
                        fak.P_22C = "0";// atr[38];
                         if(atr[39].Equals("X")==true)
                         {
                              fak.P_23=true;
                         }
                         else
                         {
                              fak.P_23=false;
                         }
                        if(atr[40].Equals("X")==true)
                        {
                             fak.P_106E_2=true;
                        }
                        else{
                             fak.P_106E_2=false;
                        }
                       if(atr[41].Equals("X")==true)
                       {
                            fak.P_106E_3=true;
                       }
                       else
                       {
                            fak.P_106E_3=false;
                       //     fak.P_106E_3A=atr[39];
                       }
                         if(atr[39].Equals("KOREKTA")==true)
                         {
                        fak.RodzajFaktury= JPK_FA_v1.JPKFakturaRodzajFaktury.KOREKTA;
                         }
                         if (atr[39].Equals("VAT") == true)
                         {
                        fak.RodzajFaktury= JPK_FA_v1.JPKFakturaRodzajFaktury.VAT;
                         }
                         if (atr[39].Equals("ZAL") == true)
                         {
                        fak.RodzajFaktury= JPK_FA_v1.JPKFakturaRodzajFaktury.ZAL;
                         }
                        
                             fak.PrzyczynaKorekty=atr[40];
                        if(fak.PrzyczynaKorekty.Equals(""))
                        {
                            fak.PrzyczynaKorekty = "_";
                        }
                        fak.NrFaKorygowanej=atr[41];
                        if (fak.NrFaKorygowanej.Equals(""))
                        {
                            fak.NrFaKorygowanej = "_";
  
                        }
                        fak.OkresFaKorygowanej=atr[42];
                        if (fak.OkresFaKorygowanej.Equals(""))
                        {
                            fak.OkresFaKorygowanej = "_";
                        }
                        //    fak.ZALZaplata=Convert.ToDecimal(atr[43].Replace('.', ','));;
                        //      fak.ZALPodatek = Convert.ToDecimal(atr[44].Replace('.', ',')); ;
                        liczba = liczba + 1;
                        fakctr.WartoscFaktur = fakctr.WartoscFaktur + fak.P_15;
                        fa.Faktura.Add(fak);
                     }

                 }
                  
               // fa.StawkiPodatku.Stawka1 = (decimal)0.23;
                 fakctr.LiczbaFaktur = liczba.ToString();
                 wierszctrl.LiczbaWierszyFaktur = liczba1.ToString();
                 fa.FakturaCtrl = fakctr;
                 fa.FakturaWierszCtrl = wierszctrl;
                 fa.SaveToFile(fileOut.Text);
             }
			 else if(Kg == true)
		     {
				JPK_KG_v1.JPK kg = new JPK_KG_v1.JPK();
				if (wal.Waluta[CWaluta.SelectedIndex].Kod.Equals("PLN") == true)
				{
					kg.Naglowek.DomyslnyKodWaluty = JPK_KG_v1.currCode_Type.PLN;
				}
				else
				{
					kg.Naglowek.DomyslnyKodWaluty = JPK_KG_v1.currCode_Type.EUR;
				}

				if (us.Lista[cUs.SelectedIndex].Kod.Equals("0271") == true)
				{
					kg.Naglowek.KodUrzedu = JPK_KG_v1.TKodUS.Item0271;
				}
				if (us.Lista[cUs.SelectedIndex].Kod.Equals("0225") == true)
				{
					kg.Naglowek.KodUrzedu = JPK_KG_v1.TKodUS.Item0225;
				}
				DateTime s = dataDo.Value;
				kg.Naglowek.DataDo = s;
				s = dataOd.Value;
				kg.Naglowek.DataOd = s;

				string ckod = cel.Cel[cCel.SelectedIndex].Key.ToString();
				if (cel.Equals("") == true)
				{
					return;
				}
				kg.Naglowek.CelZlozenia = 1;

				DateTime sw = dateC.Value;
				kg.Naglowek.DataWytworzeniaJPK = sw;
				kg.Naglowek.KodFormularza = new JPK_KG_v1.TNaglowekKodFormularza();
				kg.Naglowek.WariantFormularza = 1;

				kg.Podmiot1.AdresPodmiotu.Gmina = jg.Lista[cJG.SelectedIndex].Gmina;
				if (jg.Lista[cJG.SelectedIndex].Kraj.Equals("PL") == true)
				{
					kg.Podmiot1.AdresPodmiotu.KodKraju = JPK_KG_v1.TKodKraju.PL;
				}
				kg.Podmiot1.AdresPodmiotu.KodPocztowy = jg.Lista[cJG.SelectedIndex].Poczta;
				kg.Podmiot1.AdresPodmiotu.Miejscowosc = jg.Lista[cJG.SelectedIndex].MiastoPoczta;
				kg.Podmiot1.AdresPodmiotu.NrDomu = jg.Lista[cJG.SelectedIndex].Budynek;
				kg.Podmiot1.AdresPodmiotu.NrLokalu = jg.Lista[cJG.SelectedIndex].Dom;
				kg.Podmiot1.AdresPodmiotu.NrLokalu = "|||";
				kg.Podmiot1.AdresPodmiotu.Poczta = jg.Lista[cJG.SelectedIndex].MiastoPoczta;
				kg.Podmiot1.AdresPodmiotu.Powiat = jg.Lista[cJG.SelectedIndex].Powiat;
				kg.Podmiot1.AdresPodmiotu.Ulica = jg.Lista[cJG.SelectedIndex].Ulica;
				kg.Podmiot1.AdresPodmiotu.Wojewodztwo = jg.Lista[cJG.SelectedIndex].Wojewodztwo;
				kg.Podmiot1.IdentyfikatorPodmiotu.NIP = jg.Lista[cJG.SelectedIndex].NIP;
				kg.Podmiot1.IdentyfikatorPodmiotu.PelnaNazwa = jg.Lista[cJG.SelectedIndex].Describe;
				kg.Podmiot1.IdentyfikatorPodmiotu.REGON = jg.Lista[cJG.SelectedIndex].Regon;

				List<JPK_KG_v1.JPKZOiS> zois = new List<JPK_KG_v1.JPKZOiS>();
				List<JPK_KG_v1.JPKKontoZapis> lko = new List<JPK_KG_v1.JPKKontoZapis>();
				List<JPK_KG_v1.JPKDziennik> ldz = new List<JPK_KG_v1.JPKDziennik>();
				JPK_KG_v1.JPKZOiS zo;
				JPK_KG_v1.JPKKontoZapis ko;
				JPK_KG_v1.JPKDziennik dz;
				int kolp = 0;
				Decimal kosumwin = 0;
				Decimal kosumma = 0;
				int dzlp = 0;
				Decimal dzsumop = 0;
				while (sr.EndOfStream == false)
				{
					line = sr.ReadLine();
					atr = line.Split('|');
					if (atr[0].Equals("ZO") == true)
					{
						zo = new JPK_KG_v1.JPKZOiS();
						zo.KodKonta = atr[2];
						zo.OpisKonta = atr[3];
						zo.TypKonta = atr[4];
						zo.KodZespolu = atr[5];
						zo.OpisZespolu = atr[6];
						zo.KodKategorii = atr[7];
						zo.OpisKategorii = atr[8];
						zo.BilansOtwarciaWinien = Convert.ToDecimal(atr[9].Replace('.', ','));
						zo.BilansOtwarciaMa = Convert.ToDecimal(atr[10].Replace('.', ',')); 
						zo.ObrotyWinien = Convert.ToDecimal(atr[11].Replace('.', ','));
						zo.ObrotyMa = Convert.ToDecimal(atr[12].Replace('.', ','));
						zo.ObrotyWinienNarast = Convert.ToDecimal(atr[13].Replace('.', ',')); 
						zo.ObrotyMaNarast = Convert.ToDecimal(atr[14].Replace('.', ','));
						zo.SaldoWinien = Convert.ToDecimal(atr[15].Replace('.', ','));
						zo.SaldoMa = Convert.ToDecimal(atr[16].Replace('.', ','));
   						zois.Add(zo);
					}
					if (atr[0].Equals("KO") == true)
					{
						ko = new JPK_KG_v1.JPKKontoZapis();
						ko.LpZapisu = atr[1];
						ko.NrZapisu = atr[2];
						ko.KodKontaWinien = atr[3];
						ko.KwotaWinien = Convert.ToDecimal(atr[4].Replace('.', ','));
						ko.KwotaWinienWaluta = Convert.ToDecimal(atr[5].Replace('.', ','));
						if (atr[6].Equals("EUR") == true)
						{
							ko.KodWalutyWinien = JPK_KG_v1.currCode_Type.EUR;
						}
						ko.OpisZapisuWinien = atr[7];
            			ko.KodKontaMa = atr[8];
						ko.KwotaMa = Convert.ToDecimal(atr[9].Replace('.', ','));
						ko.KwotaMaWaluta = Convert.ToDecimal(atr[10].Replace('.', ','));
						if (atr[11].Equals("EUR") == true)
						{
							ko.KodWalutyMa = JPK_KG_v1.currCode_Type.EUR;
						}
                        ko.KodWalutyMa = JPK_KG_v1.currCode_Type.PLN;
                        ko.KodWalutyWinien = JPK_KG_v1.currCode_Type.PLN; 

                        ko.OpisZapisuMa = atr[12];
						lko.Add(ko);
						kolp = kolp + 1;
						kosumwin = kosumwin + ko.KwotaWinien;
						kosumma = kosumma + ko.KwotaMa;
					}
					if (atr[0].Equals("DZ") == true)
					{
						dz = new JPK_KG_v1.JPKDziennik();
						dz.LpZapisuDziennika = atr[1];
						dz.NrZapisuDziennika = atr[2];
						dz.NrDowoduKsiegowego = atr[4];
						dz.OpisDziennika = atr[3];
						dz.RodzajDowodu = atr[5];
						dz.DataOperacji = new DateTime(Convert.ToInt16(atr[6].Substring(0, 4)), Convert.ToInt16(atr[6].Substring(4, 2)), Convert.ToInt16(atr[6].Substring(6, 2))); 
						dz.DataDowodu = new DateTime(Convert.ToInt16(atr[7].Substring(0, 4)), Convert.ToInt16(atr[7].Substring(4, 2)), Convert.ToInt16(atr[7].Substring(6, 2)));
						dz.DataKsiegowania = new DateTime(Convert.ToInt16(atr[8].Substring(0, 4)), Convert.ToInt16(atr[8].Substring(4, 2)), Convert.ToInt16(atr[8].Substring(6, 2)));
						dz.KodOperatora = atr[9];
						dz.OpisOperacji = atr[10];
						dz.DziennikKwotaOperacji = Convert.ToDecimal(atr[11].Replace('.', ','));
						ldz.Add(dz);
						dzlp = dzlp + 1;
						dzsumop = dzsumop + dz.DziennikKwotaOperacji;
					}

				}
				kg.DziennikCtrl = new JPK_KG_v1.JPKDziennikCtrl();
				kg.DziennikCtrl.LiczbaWierszyDziennika = dzlp.ToString();
				kg.DziennikCtrl.SumaKwotOperacji = dzsumop;
				kg.KontoZapisCtrl = new JPK_KG_v1.JPKKontoZapisCtrl();
				kg.KontoZapisCtrl.LiczbaWierszyKontoZapisj = kolp.ToString();
				kg.KontoZapisCtrl.SumaMa = kosumma;
				kg.KontoZapisCtrl.SumaWinien = kosumwin;
				kg.ZOiS = zois;
				kg.KontoZapis = lko;
				kg.Dziennik = ldz;

                this.zois.clearZOIS();
                foreach (var item in kg.ZOiS)
                {
                    this.zois.addPozZOIS(item);
                }
                this.kgza.clearkgza();
                foreach (var item in kg.KontoZapis)
                {
                    this.kgza.addPozkgza(item);
                }
                kg.SaveToFile(fileOut.Text);
				
			 }
             else if(WB == true)
            {
                JPK_WB_v1.JPK wb = new JPK_WB_v1.JPK();
                if (wal.Waluta[CWaluta.SelectedIndex].Kod.Equals("PLN") == true)
                {
                    wb.Naglowek.DomyslnyKodWaluty = JPK_WB_v1.currCode_Type.PLN;
                }
                else
                {
                    wb.Naglowek.DomyslnyKodWaluty = JPK_WB_v1.currCode_Type.EUR;
                }

                if (us.Lista[cUs.SelectedIndex].Kod.Equals("0271") == true)
                {
                    wb.Naglowek.KodUrzedu = JPK_WB_v1.TKodUS.Item0271;
                }
                if (us.Lista[cUs.SelectedIndex].Kod.Equals("0225") == true)
                {
                    wb.Naglowek.KodUrzedu = JPK_WB_v1.TKodUS.Item0225;
                }
                DateTime s = dataDo.Value;
                wb.Naglowek.DataDo = s;
                s = dataOd.Value;
                wb.Naglowek.DataOd = s;

                string ckod = cel.Cel[cCel.SelectedIndex].Key.ToString();
                if (cel.Equals("") == true)
                {
                    return;
                }
                wb.Naglowek.CelZlozenia = Convert.ToSByte(ckod);

                DateTime sw = dateC.Value;
                wb.Naglowek.DataWytworzeniaJPK = sw;
                wb.Naglowek.KodFormularza = new JPK_WB_v1.TNaglowekKodFormularza();
                wb.Naglowek.WariantFormularza = 1;

                wb.Podmiot1.AdresPodmiotu.Gmina = jg.Lista[cJG.SelectedIndex].Gmina;
                if (jg.Lista[cJG.SelectedIndex].Kraj.Equals("PL") == true)
                {
                    wb.Podmiot1.AdresPodmiotu.KodKraju = JPK_WB_v1.TKodKraju.PL;
                }
                wb.Podmiot1.AdresPodmiotu.KodPocztowy = jg.Lista[cJG.SelectedIndex].Poczta;
                wb.Podmiot1.AdresPodmiotu.Miejscowosc = jg.Lista[cJG.SelectedIndex].MiastoPoczta;
                wb.Podmiot1.AdresPodmiotu.NrDomu = jg.Lista[cJG.SelectedIndex].Budynek;
                wb.Podmiot1.AdresPodmiotu.NrLokalu = jg.Lista[cJG.SelectedIndex].Dom;
                wb.Podmiot1.AdresPodmiotu.NrLokalu = "|||";
                wb.Podmiot1.AdresPodmiotu.Poczta = jg.Lista[cJG.SelectedIndex].MiastoPoczta;
                wb.Podmiot1.AdresPodmiotu.Powiat = jg.Lista[cJG.SelectedIndex].Powiat;
                wb.Podmiot1.AdresPodmiotu.Ulica = jg.Lista[cJG.SelectedIndex].Ulica;
                wb.Podmiot1.AdresPodmiotu.Wojewodztwo = jg.Lista[cJG.SelectedIndex].Wojewodztwo;
                wb.Podmiot1.IdentyfikatorPodmiotu.NIP = jg.Lista[cJG.SelectedIndex].NIP;
                wb.Podmiot1.IdentyfikatorPodmiotu.PelnaNazwa = jg.Lista[cJG.SelectedIndex].Describe;
                wb.Podmiot1.IdentyfikatorPodmiotu.REGON = jg.Lista[cJG.SelectedIndex].Regon;
                int licz = 0;
                JPK_WB_v1.JPKWyciagWiersz wp;
                JPK_WB_v1.JPKWyciagCtrl wpc = new JPK_WB_v1.JPKWyciagCtrl();
                while (sr.EndOfStream == false)
                {
                    line = sr.ReadLine();
                    atr = line.Split('|');


                    if (atr[0].Equals("SA") == true)
                    {
                        wb.NumerRachunku = atr[2];
                        wb.Salda.SaldoPoczatkowe = Convert.ToDecimal(atr[3].Replace('.', ','));
                        wb.Salda.SaldoKoncowe = Convert.ToDecimal(atr[4].Replace('.', ','));
                    }
                    if (atr[0].Equals("PO") == true)
                    {
                        licz = licz + 1;
                        wp = new JPK_WB_v1.JPKWyciagWiersz();
                        wp.NumerWiersza = atr[1].ToString();
                        wp.DataOperacji = new DateTime(Convert.ToInt16(atr[2].Substring(0, 4)), Convert.ToInt16(atr[2].Substring(4, 2)), Convert.ToInt16(atr[2].Substring(6, 2)));
                        wp.NazwaPodmiotu = atr[3] + atr[4];
                        wp.OpisOperacji = atr[5];
                        wp.KwotaOperacji = Convert.ToDecimal(atr[6].Replace('.', ','));
                        wp.SaldoOperacji = Convert.ToDecimal(atr[7].Replace('.', ','));
                        WBPozycje.addPozWB(wp);
                        if (wp.KwotaOperacji > 0)
                        {
                            wpc.SumaUznan = wpc.SumaUznan + wp.KwotaOperacji;
                        }
                        else
                        {
                            wpc.SumaObciazen = wpc.SumaObciazen + wp.KwotaOperacji;
                        }
                        wb.WyciagWiersz.Add(wp);
                    }
                }
                wpc.LiczbaWierszy = licz.ToString();
                wb.WyciagCtrl = wpc;
                wb.SaveToFile(fileOut.Text);
            }
            else
             {
                 JPK_VAT_v1.JPK vat = new JPK_VAT_v1.JPK();
                 if (cUs.SelectedIndex < 0)
                 {
                     return;
                 }


                 if (us.Lista[cUs.SelectedIndex].Kod.Equals("0271") == true)
                 {
                //     vat.Naglowek.KodUrzedu = JPK_VAT_v1.TKodUS.Item0271;

                 }
				if (us.Lista[cUs.SelectedIndex].Kod.Equals("0225") == true)
				{
				//	vat.Naglowek.KodUrzedu = JPK_VAT_v1.TKodUS.Item0225;
				}
                //	vat.Naglowek.DomyslnyKodWaluty = JPK_VAT_v1.currCode_Type.PLN; 
                DateTime s = dataDo.Value;
                 vat.Naglowek.DataDo = s;
                 s = dataOd.Value;
                 vat.Naglowek.DataOd = s;

                 string ckod = cel.Cel[cCel.SelectedIndex].Key.ToString();
                 if (cel.Equals("") == true)
                 {
                     return;
                 }
                 vat.Naglowek.CelZlozenia = ckod;

                 DateTime sw = dateC.Value;
                 vat.Naglowek.DataWytworzeniaJPK = sw;

                 vat.Naglowek.KodFormularza = new JPK_VAT_v1.TNaglowekKodFormularza();
                 vat.Naglowek.WariantFormularza = 3;
                vat.Naglowek.NazwaSystemu = "SAP";
                vat.Podmiot1.Email = "anna.cebo@ideagetin.pl";
               //  vat.Podmiot1.AdresPodmiotu.Gmina = jg.Lista[cJG.SelectedIndex].Gmina;
                 if (jg.Lista[cJG.SelectedIndex].Kraj.Equals("PL") == true)
                 {
             //        vat.Podmiot1.AdresPodmiotu.KodKraju = JPK_VAT_v1.TKodKraju.PL;
                 }
              //   vat.Podmiot1.AdresPodmiotu.KodPocztowy = jg.Lista[cJG.SelectedIndex].Poczta;
              //   vat.Podmiot1.AdresPodmiotu.Miejscowosc = jg.Lista[cJG.SelectedIndex].MiastoPoczta;
              //   vat.Podmiot1.AdresPodmiotu.NrDomu = jg.Lista[cJG.SelectedIndex].Budynek;
              //   vat.Podmiot1.AdresPodmiotu.NrLokalu = jg.Lista[cJG.SelectedIndex].Dom;
              //   vat.Podmiot1.AdresPodmiotu.NrLokalu = "|||";
              //   vat.Podmiot1.AdresPodmiotu.Poczta = jg.Lista[cJG.SelectedIndex].MiastoPoczta;
              //   vat.Podmiot1.AdresPodmiotu.Powiat = jg.Lista[cJG.SelectedIndex].Powiat;
              //   vat.Podmiot1.AdresPodmiotu.Ulica = jg.Lista[cJG.SelectedIndex].Ulica;
              //   vat.Podmiot1.AdresPodmiotu.Wojewodztwo = jg.Lista[cJG.SelectedIndex].Wojewodztwo;
                 vat.Podmiot1.NIP = jg.Lista[cJG.SelectedIndex].NIP;
                 vat.Podmiot1.PelnaNazwa = jg.Lista[cJG.SelectedIndex].Describe;
               //  vat.Podmiot1.IdentyfikatorPodmiotu.REGON = jg.Lista[cJG.SelectedIndex].Regon;

                 JPK_VAT_v1.JPKSprzedazWiersz sp;

                 ProgresMy po = new ProgresMy();
                 po.Start();

                 while (sr.EndOfStream == false)
                 {
                     line = sr.ReadLine();
                     atr = line.Split('|');
                     if (atr[1].Equals("S") == true)
                     {
                         sp = new JPK_VAT_v1.JPKSprzedazWiersz();
                         sp.LpSprzedazy = Convert.ToInt32(atr[0]).ToString();
                         sp.DowodSprzedazy = atr[5];
                         sp.NazwaKontrahenta = atr[6];
                         sp.AdresKontrahenta = atr[7];
                         sp.NrKontrahenta = atr[46];
                         sp.DataSprzedazy = new DateTime(Convert.ToInt16(atr[3].Substring(0, 4)), Convert.ToInt16(atr[3].Substring(4, 2)), Convert.ToInt16(atr[3].Substring(6, 2)));
                  //       sp.DataSprzedazySpecified = true;
                         sp.DataWystawienia = new DateTime(Convert.ToInt16(atr[4].Substring(0, 4)), Convert.ToInt16(atr[4].Substring(4, 2)), Convert.ToInt16(atr[4].Substring(6, 2)));

                         sp.K_10 = Convert.ToDecimal(atr[8].Replace('.', ','));
                         if (sp.K_10 != 0)
                         {
                 //            sp.K_10Specified = true;
                         }
                         sp.K_11 = Convert.ToDecimal(atr[9].Replace('.', ','));
                         if (sp.K_11 != 0)
                         {
                    //         sp.K_11Specified = true;
                         }
                         sp.K_12 = Convert.ToDecimal(atr[10].Replace('.', ','));
                         if (sp.K_12 != 0)
                         {
                    //         sp.K_12Specified = true;
                         }
                         sp.K_13 = Convert.ToDecimal(atr[11].Replace('.', ','));
                         if (sp.K_13 != 0)
                         {
                    //         sp.K_13Specified = true;
                         }
                         sp.K_14 = Convert.ToDecimal(atr[12].Replace('.', ','));
                         if (sp.K_14 != 0)
                         {
                    //         sp.K_14Specified = true;
                         }
                         sp.K_15 = Convert.ToDecimal(atr[13].Replace('.', ','));
                         sp.K_16 = Convert.ToDecimal(atr[14].Replace('.', ','));
                         sp.K_17 = Convert.ToDecimal(atr[15].Replace('.', ','));
                         sp.K_18 = Convert.ToDecimal(atr[16].Replace('.', ','));
                         sp.K_19 = Convert.ToDecimal(atr[17].Replace('.', ','));
                         sp.K_20 = Convert.ToDecimal(atr[18].Replace('.', ','));
                         sp.K_21 = Convert.ToDecimal(atr[19].Replace('.', ','));
                         if (sp.K_21 != 0)
                         {
                    //         sp.K_21Specified = true;
                         }
                         sp.K_22 = Convert.ToDecimal(atr[20].Replace('.', ','));
                         if (sp.K_22 != 0)
                         {
                      //       sp.K_22Specified = true;
                         }
                         sp.K_23 = Convert.ToDecimal(atr[21].Replace('.', ','));
                         sp.K_24 = Convert.ToDecimal(atr[22].Replace('.', ','));
                         sp.K_25 = Convert.ToDecimal(atr[23].Replace('.', ','));
                         sp.K_26 = Convert.ToDecimal(atr[24].Replace('.', ','));
                         sp.K_27 = Convert.ToDecimal(atr[25].Replace('.', ','));
                         sp.K_28 = Convert.ToDecimal(atr[26].Replace('.', ','));
                         sp.K_29 = Convert.ToDecimal(atr[27].Replace('.', ','));
                         sp.K_30 = Convert.ToDecimal(atr[28].Replace('.', ','));
                         sp.K_31 = Convert.ToDecimal(atr[29].Replace('.', ','));
                         if (sp.K_31 != 0)
                         {
                   //          sp.K_31Specified = true;
                         }
                         sp.K_32 = Convert.ToDecimal(atr[30].Replace('.', ','));
                         sp.K_33 = Convert.ToDecimal(atr[31].Replace('.', ','));
                         sp.K_34 = Convert.ToDecimal(atr[32].Replace('.', ','));
                         sp.K_35 = Convert.ToDecimal(atr[33].Replace('.', ','));
                         sp.K_36 = Convert.ToDecimal(atr[34].Replace('.', ','));
                         if (sp.K_36 != 0)
                         {
                    //         sp.K_36Specified = true;
                         }
                         sp.K_37 = Convert.ToDecimal(atr[35].Replace('.', ','));
                         if (sp.K_37 != 0)
                         {
                     //        sp.K_37Specified = true;
                         }
                         sp.K_38 = Convert.ToDecimal(atr[36].Replace('.', ','));
                         if (sp.K_38 != 0)
                         {
                     //        sp.K_38Specified = true;
                         }
                         sp.K_39 = Convert.ToDecimal(atr[37].Replace('.', ','));
                         if (sp.K_39 != 0)
                         {
                      //       sp.K_39Specified = true;
                         }
                         vat.SprzedazWiersz.Add(sp);
                     }
                     else
                     {
                         JPK_VAT_v1.JPKZakupWiersz zk = new JPK_VAT_v1.JPKZakupWiersz();
                         zk.LpZakupu = Convert.ToInt32(atr[0]).ToString();
                         zk.DowodZakupu = atr[5];
                         zk.NazwaDostawcy = atr[6];
                         zk.AdresDostawcy = atr[7];
                         zk.NrDostawcy = atr[46];
                         zk.DataWplywu = new DateTime(Convert.ToInt16(atr[3].Substring(0, 4)), Convert.ToInt16(atr[3].Substring(4, 2)), Convert.ToInt16(atr[3].Substring(6, 2)));
                     //    zk.DataWplywuSpecified = true;
                         zk.DataZakupu = new DateTime(Convert.ToInt16(atr[4].Substring(0, 4)), Convert.ToInt16(atr[4].Substring(4, 2)), Convert.ToInt16(atr[4].Substring(6, 2)));
                         zk.K_43 = Convert.ToDecimal(atr[38].Replace('.', ','));
                         zk.K_44 = Convert.ToDecimal(atr[39].Replace('.', ','));
                         zk.K_45 = Convert.ToDecimal(atr[40].Replace('.', ','));
                         zk.K_46 = Convert.ToDecimal(atr[41].Replace('.', ','));
                         zk.K_47 = Convert.ToDecimal(atr[42].Replace('.', ','));
						if (zk.K_47 != 0)
						{
					//		zk.K_47Specified = true;
						}
                         zk.K_48 = Convert.ToDecimal(atr[43].Replace('.', ','));
						if (zk.K_48 != 0)
						{
					//		zk.K_48Specified = true;
						}
						zk.K_49 = Convert.ToDecimal(atr[44].Replace('.', ','));
                         zk.K_50 = Convert.ToDecimal(atr[45].Replace('.', ','));
                         vat.ZakupWiersz.Add(zk);
                     }

                 }
                if(vat.SprzedazWiersz.Count > 0)
                {
                    vat.SprzedazCtrl.PodatekNalezny = 0;
                    vat.SprzedazCtrl.LiczbaWierszySprzedazy = vat.SprzedazWiersz.Count.ToString();
                    foreach (var item in vat.SprzedazWiersz)
                    {
                        vat.SprzedazCtrl.PodatekNalezny = vat.SprzedazCtrl.PodatekNalezny + item.K_20 + item.K_18 + item.K_16 + item.K_24 + item.K_26 + item.K_28 + item.K_30 + item.K_33 + item.K_35 + item.K_36 + item.K_37 - item.K_38 - item.K_39;
                    }
                }else
                {
                    vat.SprzedazCtrl = null;
                }
                if (vat.ZakupWiersz.Count > 0)
                {
                    vat.ZakupCtrl.PodatekNaliczony = 0;
                    vat.ZakupCtrl.LiczbaWierszyZakupow = vat.ZakupWiersz.Count.ToString();
                    foreach (var item in vat.ZakupWiersz)
                    {
                        vat.ZakupCtrl.PodatekNaliczony = vat.ZakupCtrl.PodatekNaliczony + item.K_44 + item.K_46 + item.K_47 + item.K_48;
                    }
                }
                else
                {
                    vat.ZakupCtrl = null;
                }
                 vat.SaveToFile(fileOut.Text);
                 po.Stop();
             }
             tstatus.Text = "Wygenerowano plik " + Path.GetFileName(fileOut.Text);
         }

         private void cUs_SelectedIndexChanged(object sender, EventArgs e)
         {
             tDesUS.Text =  us.Lista[cUs.SelectedIndex].Describe;
         }

         private void cJG_SelectedIndexChanged(object sender, EventArgs e)
         {
             tJG.Text = jg.Lista[cJG.SelectedIndex].Describe;
             lPodmiot.SetPodmiot(jg.Lista[cJG.SelectedIndex]);

         }

         private void button1_Click(object sender, EventArgs e)
         {
             string file = Path.GetFileNameWithoutExtension(fileOut.Text);
             String files = Path.GetDirectoryName(fileOut.Text);
             files = files + "\\" + file;
             Directory.CreateDirectory(files);
             String path1 = files +"\\"+ Path.GetFileNameWithoutExtension(fileOut.Text) +".xml";
             File.Copy(fileOut.Text, path1,true);
             file = Path.GetDirectoryName(fileOut.Text) + "\\" + Path.GetFileNameWithoutExtension(fileOut.Text) + ".zip";
             //ZipFile.CreateFromDirectory(files, file);
             //Szyfruje 
             tstatus.Text = "Szyfruje plik " + file;
             String key =  @"5TGB&YHN7UJM(IK<5TGB&YHN7UJM(IK<";
             byte[] datOut = Encrypt256(file, key);
             //Podpisuje klucz
             tstatus.Text = "Podpisuje klucz";
             OpenFileDialog openFileDialog1 = new OpenFileDialog();
             openFileDialog1.Multiselect = false;
             openFileDialog1.Title = "Podaj plik z kluczem do podpisu";
             openFileDialog1.Filter = "PEM|*.pem";
             byte[] sigKey = null;
             if (openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
             {
                 sigKey = SigKey(key, openFileDialog1.FileName);
             }
             //Wysyłam
             tstatus.Text = "Wysyłam";
             string hashxml;
             System.Security.Cryptography.SHA256 SH = System.Security.Cryptography.SHA256.Create();
             BinaryReader reader = new BinaryReader(File.Open(path1, FileMode.Open));
             byte[] src =  reader.ReadBytes((int)reader.BaseStream.Length);
             hashxml = Convert.ToBase64String(SH.ComputeHash(src));
             string keybase64 = Convert.ToBase64String(SH.ComputeHash(sigKey));
             SendSessionFile(datOut, keybase64, Path.GetFileName(path1), Path.GetFileName(file), hashxml);

         }

         private void SendSessionFile(byte[] datOut, string sigKey, string file, string filezip, string hashxml)
         {
             InitUploadType inittyp = new InitUploadType();
             inittyp.DocumentType = InitUploadTypeDocumentType.JPK;

             //klucze
       //      inittyp.EncryptionKey = new InitUploadTypeEncryptionKey();
             inittyp.EncryptionKey.algorithm = "RSA";
             inittyp.EncryptionKey.mode = "ECB";
             inittyp.EncryptionKey.padding = "PKCS#1";
             inittyp.EncryptionKey.encoding = "Base64";
             inittyp.EncryptionKey.Value = sigKey;
              //lista dokumentow
     
             JPK_VAT_v1.JPK jpk = new JPK_VAT_v1.JPK();


             ArrayOfDocumentTypeDocument d1 = inittyp.DocumentList.Document;
             //   DocumentType dok = new DocumentType();
             d1.FormCode = new DocumentTypeFormCode();
             d1.FormCode.Value = jpk.Naglowek.KodFormularza.Value.ToString();
             d1.FormCode.schemaVersion = jpk.Naglowek.KodFormularza.wersjaSchemy;
             d1.FormCode.systemCode = jpk.Naglowek.KodFormularza.kodSystemowy;
             d1.FileName = file;
             d1.ContentLength = datOut.Length;

             MD5 md5 = null;

             byte[] hash  = null;

             d1.HashValue.Value = hashxml;

             d1.FileSignatureList.filesNumber = 1;

           //  d1.FileSignatureList.Packaging = new ArrayOfFileSignatureTypePackaging();

        //     d1.FileSignatureList.Encryption = new ArrayOfFileSignatureTypeEncryption();

             d1.FileSignatureList.Encryption.Item.IV.Value = @"!QAZ2WSX#EDC4RFV";

        //     d1.FileSignatureList.FileSignature = new List<FileSignatureType>();
             FileSignatureType f = new FileSignatureType();
             f.OrdinalNumber = 1;
             f.FileName = filezip;
             f.ContentLength = datOut.Length;
             md5 = System.Security.Cryptography.MD5.Create();
             hash = md5.ComputeHash(datOut);
             f.HashValue.Value = Convert.ToBase64String(hash);
             d1.FileSignatureList.FileSignature.Add(f);

           
             string xml2 = inittyp.Serialize();

           Signed s1 = new Signed();
           s1.XmlIN = xml2;
           s1.RunSigned(false);
           String xmlout = s1.XmlOut;

           String url = "https://test-e-dokumenty.mf.gov.pl/api/Storage/InitUploadSigned";

           String dataout = HttpPost(url, xmlout);
 

         }

         public  string HttpPost(string url,  string paramVal)
         {
             ServicePointManager.Expect100Continue = true;
             ServicePointManager.ServerCertificateValidationCallback += new System.Net.Security.RemoteCertificateValidationCallback(ValidateServerCertificate);
             ServicePointManager.SecurityProtocol = SecurityProtocolType.Tls;
       
             HttpWebRequest req = WebRequest.Create(new Uri(url))
                                  as HttpWebRequest;
             req.Method = "POST";
             req.ContentType = "application/xml";
             req.Accept = "*/*";
             DateTime dt = new DateTime();
             dt = DateTime.Now;
             req.Date = dt;
             // Build a ring with all the params, properly encoded.
             // We assume that the arrays paramName and paramVal are
             // of equal length:
             StringBuilder paramz = new StringBuilder();
            

             paramz.Append(paramVal);
             
             // Encode the parameters as form data:
             byte[] formData =
                 UTF8Encoding.UTF8.GetBytes(paramz.ToString());
             req.ContentLength = formData.Length;
              X509SelectionFlag sele;
              X509Certificate2Collection col;
             X509Store store = new X509Store(StoreName.My, StoreLocation.CurrentUser);
             store.Open(OpenFlags.MaxAllowed);
      
                 sele = X509SelectionFlag.SingleSelection;
                 col = X509Certificate2UI.SelectFromCollection(store.Certificates, "Wybierz", "Wybierz", sele);
            
             store.Close();
             req.KeepAlive = false;
             req.PreAuthenticate = true;
             req.AllowAutoRedirect = true;
             req.ProtocolVersion = HttpVersion.Version10;
             req.ClientCertificates = col;
             req.Credentials = CredentialCache.DefaultCredentials;
             req.Proxy = null;
             req.ServicePoint.ConnectionLimit = 1;
             // Send the request:
             try
             {
                using (Stream post = req.GetRequestStream())
                {
                    post.Write(formData, 0, formData.Length);
                }
             }
             catch (WebException e)
             {

                 throw;
             }

             // Pick up the response:
             string result = null;
             try
             {



                 using (HttpWebResponse resp = req.GetResponse()
                                               as HttpWebResponse)
                 {
                     StreamReader reader =
                         new StreamReader(resp.GetResponseStream());
                     result = reader.ReadToEnd();
                 }
             }
             catch (WebException wex)
             {
                 if (wex.Response != null)
                 {
                     using (var errorResponse = (HttpWebResponse)wex.Response)
                     {
                         using (var reader = new StreamReader(errorResponse.GetResponseStream()))
                         {
                             string error = reader.ReadToEnd();
                             //TODO: use JSON.net to parse this string and look at the error message
                          //   var results = Newtonsoft.Json.JsonConvert.DeserializeObject<ErrorMessage>(error);
                           //  string a = results.Message;
                         }
                     }
                 }

             }
             return result;
         }


         private byte[] SigKey(string key, string publicKey)
         {
             UnicodeEncoding _encoder = new UnicodeEncoding();
             byte[] encryptData;
             RSACryptoServiceProvider rsa = new RSACryptoServiceProvider();
             byte[] Exponent = { 1, 0, 1 };
             RSAParameters rsaParam = rsa.ExportParameters(false);
             rsaParam.Modulus = Convert.FromBase64String(File.ReadAllText(publicKey).Replace("-----BEGIN CERTIFICATE-----", "").Replace("-----END CERTIFICATE-----", ""));
             rsaParam.Exponent = Exponent;
             rsa.ImportParameters(rsaParam);
             var dataToEncrypt = _encoder.GetBytes(key);
             encryptData = rsa.Encrypt(dataToEncrypt, false);
             return encryptData;
         }
         private byte[] Encrypt256(string file, string key)
         {
             AesCryptoServiceProvider aes = new AesCryptoServiceProvider();
             string AesIV256 = @"!QAZ2WSX#EDC4RFV";
             aes.BlockSize = 128;
             aes.KeySize = 128;
             aes.Mode = CipherMode.CBC;
             aes.Padding = PaddingMode.PKCS7;
             aes.IV = Encoding.UTF8.GetBytes(AesIV256);
             aes.Key = Encoding.UTF8.GetBytes(key);
             BinaryReader reader = new BinaryReader(File.Open(file, FileMode.Open));
             byte[] src =  reader.ReadBytes((int)reader.BaseStream.Length);
             using (ICryptoTransform encrypt = aes.CreateEncryptor())
             {
                 byte[] dest = encrypt.TransformFinalBlock(src, 0, src.Length);
                 return dest;
             }
         }
         public static bool ValidateServerCertificate(object sender, X509Certificate certificate, X509Chain chain, SslPolicyErrors sslPolicyErrors)
         {
             return true;
         }
  
    }

}
