﻿using System;
using System.Collections.Generic;
using System.Deployment.Internal.CodeSigning;
using System.Linq;
using System.Security.Cryptography;
using System.Security.Cryptography.X509Certificates;
using System.Security.Cryptography.Xml;
using System.Text;
using System.Threading.Tasks;
using System.Xml;


namespace JPK_v1
{
    public class Signed
    {
        public String XmlIN { get; set; }
        public String XmlOut { get; set; }

        private RSACryptoServiceProvider csp;
        private X509SelectionFlag sele;
        private X509Certificate2Collection col;

        public Signed()
        {
            XmlIN = "";
            XmlOut = "";
        }

        public int RunSigned(bool sel)
        {
            if (XmlIN == "")
            {
                return -1;
            }
            X509Store store = new X509Store(StoreName.My, StoreLocation.CurrentUser);
            store.Open(OpenFlags.MaxAllowed);

            csp = new RSACryptoServiceProvider();
            if (sel == false)
            {
                sele = X509SelectionFlag.SingleSelection;
                col = X509Certificate2UI.SelectFromCollection(store.Certificates, "Wybierz", "Wybierz", sele);
            }
            store.Close();
            if (col.Count > 0)
            {
                X509Certificate2 cert1 = col[0];

                KeyInfoX509Data keyData = new KeyInfoX509Data();
                //   keyData.AddSubjectName(cert1.FriendlyName);
                keyData.AddSubjectName(cert1.SubjectName.Name);
                //   keyData.AddIssuerSerial(cert1.FriendlyName,cert1.GetSerialNumberString());
                csp = (RSACryptoServiceProvider)cert1.PrivateKey;
                
                RSACryptoServiceProvider rsaKey = csp;
               
                XmlDocument xmlDoc = new XmlDocument();
   
                xmlDoc.LoadXml(XmlIN);

   //             xmlDoc = XadesHelper.Sign(xmlDoc).Using(cert1).
     //           IncludingCertificateInSignature().SignAndGetXml();


                XmlNodeList xnList = xmlDoc.GetElementsByTagName("Signature");
                if (xnList.Count == 0)
                {
                    int test = SignXml(xmlDoc, rsaKey, keyData);
                    if (test == 0)
                    {
                        XmlOut = xmlDoc.OuterXml;
                        return 1;
                    }
                    else
                    {
                        return -1;
                    }
                }
                else
                {
                    XmlOut = xmlDoc.OuterXml;
                }
            }



            return 0;
        }
        public static int SignXml(XmlDocument xmlDoc, AsymmetricAlgorithm Key, KeyInfoX509Data keydata)
        {
            // Check arguments. 
          /*    CryptoConfig.AddAlgorithm(typeof(RSAPKCS1SHA256SignatureDescription), "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256");
            if (xmlDoc == null)
                throw new ArgumentException("xmlDoc");
            if (Key == null)
                throw new ArgumentException("Key");

            // Create a SignedXml object.
            SignedXml signedXml = new SignedXml(xmlDoc);
            KeyInfo keyInfo = new KeyInfo();

      //      XaDesSignedXml xades;

            keyInfo.AddClause(keydata);
            signedXml.Signature.Id = "ID" + "20160808";
            signedXml.KeyInfo = keyInfo;
            signedXml.SignedInfo.SignatureMethod = "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256";
            // Add the key to the SignedXml document.
            signedXml.SigningKey = Key;
 
            // Create a reference to be signed.
            Reference reference = new Reference();
            reference.Uri = "";

            // Add an enveloped transformation to the reference.
            
            
            reference.AddTransform(new XmlDsigEnvelopedSignatureTransform());
            reference.AddTransform(new XmlDsigExcC14NTransform());
            reference.DigestMethod = "http://www.w3.org/2001/04/xmlenc#sha256";

         //   XmlDsigEnvelopedSignatureTransform env = new XmlDsigEnvelopedSignatureTransform();
            

         //   reference.AddTransform(env);

            // Add the reference to the SignedXml object.
            signedXml.AddReference(reference);
     
            // Compute the signature.
            try
            {
                signedXml.ComputeSignature();
            }
            catch (CryptographicException c)
            {
                return 1;
            }
            // Get the XML representation of the signature and save 
            // it to an XmlElement object.
            XmlElement xmlDigitalSignature = signedXml.GetXml();
         //   xmlDigitalSignature.SetAttribute("Id", signedXml.Signature.Id);
           
            // Append the element to the XML document.
            
            xmlDoc.DocumentElement.AppendChild(xmlDoc.ImportNode(xmlDigitalSignature, true)); */
            return 0;
        }
    }
}
